/***************************************************************************/
/*                                                                         */
/*  CLASS NAME: Demo                                                       */
/*  PACKAGE:                                                               */
/*  PROJECT:    TimeDB 2.0                                                 */
/*  AUTHOR:     Andreas Steiner                                            */
/*  DATE:       September 3, 1999                                          */
/*                                                                         */
/***************************************************************************/


public class Demo {

  public static void main(String[] args) {

    TDBCI t = new TDBCI(); // Create a new interface object

    // Set TimeDB Preferences :
    if (t.setPrefs("C:\\TimeDB2.0B4\\",               // Path to TimeDB2.0 directory 
                   1,                                 // Using Oracle DBMS
                   "oracle.jdbc.driver.OracleDriver", // Oracle's JDBC driver
                   "jdbc:oracle:thin:1521:ORCL"))     // URL
    {
      if (t.openDB("scott", "tiger")) { // Open Database

        if (t.createDB()) { // Initialise DB with Metadata

          // Execute ATSQL2 statements :
          ResultSet output = t.execute("CREATE TABLE p(X INTEGER) AS VALIDTIME;");
          System.out.println(output.createString());

          output = t.execute("VALIDTIME PERIOD [1983-1987) INSERT INTO p VALUES (1);");
          System.out.println(output.createString());

          output = t.execute("VALIDTIME PERIOD [1983-1987) INSERT INTO p VALUES (2);");
          System.out.println(output.createString());

          // Query :
          output = t.execute("VALIDTIME SELECT * FROM p;");
          // 1. Possibility for query output : Create a string of result table
          System.out.println(output.createString()); 

          // 2. Possibility for query output : Iterate through result table
          ResultRow row = output.firstRow(); // Get first row of result table
          while (row != null) {
            int i = 0;
            String value = null;
            while ((value = row.getColumnValue(i)) != null) // Get next value in row
            {
              System.out.print(value);  // Print value
              System.out.print(" [" + row.getColumnType(i) + "]  ");  // Print type of value
              i++;
            }
            row = output.nextRow(row); // Get next row of result table
            System.out.println();
          }

          output = t.execute("DROP TABLE p;");
          System.out.println(output.createString());

          if (!t.clearDB()) { // Delete Metadata
            System.out.println("Could not delete metadata from scott/tiger");
          }
          t.closeDB(); // Close database
        }
        else System.out.println("Could not create metadata in scott/tiger");
      }
      else System.out.println("Could not open scott/tiger"); 
    }
    else System.out.println("Could not write preference file in C:\\TimeDB2.0");
  }

}
