/***************************************************************************/
/*                                                                         */
/*  CLASS NAME: TDBCInterface                                              */
/*  PACKAGE:    Interface                                                  */
/*  PROJECT:    TimeDB 2.0                                                 */
/*  AUTHOR:     Andreas Steiner                                            */
/*  DATE:       September 4, 1999                                          */
/*                                                                         */
/***************************************************************************/


public interface TDBCInterface {

  /*****************************************************/
  /*************** PUBLIC INSTANCE METHODS *************/
  /*****************************************************/

  /* Set TimeDB Preferences */
  public boolean setPrefs(String Path, int DBMS, String JDBCDriver, String URL);
  /* Oracle            : DBMS = 1 */
  /* Sybase            : DBMS = 2 */
  /* Cloudscape's JBMS : DBMS = 3 */


  /* Initialise DB with Metadata : */
  public boolean createDB();
  public boolean clearDB();


  /* Open/Close Database : */
  public boolean openDB(String Login, String Password);
  public void closeDB();


  /* Execute an ATSQL statement : */
  public ResultSet execute(String stmt);

}
